<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Support for Debugging</TITLE>
<link href="builder_44.html" rel=Next>
<link href="builder_42.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_42.html">previous</A>, <A HREF="builder_44.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC76" HREF="builder_toc.html#TOC76">Support for Debugging</A></H2>
<P>
The builder system was created to make life easier for compiler writers.
Proving good debugging support was an integral part of this philosophy.
Debugging support was provided at two levels: compile-time support
obtained from the C++ compiler and the run-time support programmed in to
the builder system. 
<A NAME="IDX707"></A>

</P>


<H3><A NAME="SEC77" HREF="builder_toc.html#TOC77">Compile-time Error Checking</A></H3>
<P>
When compiling the compiler-pass, a limited amount of error checking of
the builder structures will be provided by the C++ compiler. If operator
overloading is used, C++ compiler will check for any syntax errors.
Since all the builder structures are of the same <CODE>block</CODE> class, no
semantic checking will be provided at compile time.
<A NAME="IDX708"></A>
<A NAME="IDX709"></A>

</P>


<H3><A NAME="SEC78" HREF="builder_toc.html#TOC78">Run-Time Error Checking</A></H3>
<P>
When running the compiler pass, the builder library is invoked.  All
semantic and syntax checks are done at this level. When an error is
found, the builder will print an error message and will try to continue
executing.  This was done to help debugging since the first instance of
finding an error may not be the exact location of the error. 
<A NAME="IDX710"></A>
<A NAME="IDX711"></A>

</P>
<P>
The current error messages do not print the location information of the 
user program that called the builder routine.  Implementing this
involves converting all the user interface calls to macros. 

</P>


<H4><A NAME="SEC79" HREF="builder_toc.html#TOC79">Syntax and Semantic checking</A></H4>
<P>
A nearly complete semantic and syntax check is implemented in the
builder system.  If a semnatically or syntactically incorrect builder
structure is found a descriptive (hopefully) error message will be
printed with the line information of the builder library where the error
was located; not the line information of the user code.

</P>


<H4><A NAME="SEC80" HREF="builder_toc.html#TOC80">Checking the Generated Code</A></H4>
<P>
The builder will check the code that is generated for possible errors
and will warn the user.
<A NAME="IDX712"></A>

</P>
<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_42.html">previous</A>, <A HREF="builder_44.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
